/*
 * This file was generated automatically by xsubpp version 1.9508 from the
 * contents of PMDA.xs. Do not edit this file, edit PMDA.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "PMDA.xs"
/*
 * Copyright (c) 2008-2010 Aconex.  All Rights Reserved.
 * Copyright (c) 2004 Silicon Graphics, Inc.  All Rights Reserved.
 * 
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
 * or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
 * for more details.
 */

#include "local.h"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

static pmdaInterface dispatch;
static pmdaMetric *metrictab;
static int mtab_size;
static __pmnsTree *pmns;
static int need_refresh;
static pmdaIndom *indomtab;
static int itab_size;
static int *clustertab;
static int ctab_size;

static HV *metric_names;
static HV *metric_oneline;
static HV *metric_helptext;
static HV *indom_helptext;
static HV *indom_oneline;

static SV *fetch_func;
static SV *refresh_func;
static SV *instance_func;
static SV *store_cb_func;
static SV *fetch_cb_func;

int
clustertab_lookup(int cluster)
{
    int i, found = 0;

    for (i = 0; i < ctab_size; i++) {
	if (cluster == clustertab[i]) {
	    found = 1;
	    break;
	}
    }
    return found;
}

void
clustertab_replace(int index, int cluster)
{
    if (index >= 0 && index < ctab_size)
	clustertab[index] = cluster;
    else
	warn("invalid cluster table replacement requested");
}

void
clustertab_scratch()
{
    memset(clustertab, -1, sizeof(int) * ctab_size);
}

void
clustertab_refresh(int index)
{
    dSP;
    ENTER;
    SAVETMPS;
    PUSHMARK(sp);
    XPUSHs(sv_2mortal(newSVuv(clustertab[index])));
    PUTBACK;

    perl_call_sv(refresh_func, G_VOID);

    SPAGAIN;
    PUTBACK;
    FREETMPS;
    LEAVE;
}

void
refresh(int numpmid, pmID *pmidlist)
{
    int i, numclusters = 0;
    __pmID_int *pmid;

    /* Create list of affected clusters from pmidlist
     * Note: we overwrite the initial cluster array here, to avoid
     * allocating memory.  The initial array contains all possible
     * clusters whereas we (possibly) construct a subset here.  We
     * do not touch ctab_size at all, however, which lets us reuse
     * the preallocated array space on every fetch.
     */
    clustertab_scratch();
    for (i = 0; i < numpmid; i++) {
	pmid = (__pmID_int *) &pmidlist[i];
	if (clustertab_lookup(pmid->cluster) == 0)
	    clustertab_replace(numclusters++, pmid->cluster);
    }

    /* For each unique cluster, call the cluster refresh method */
    for (i = 0; i < numclusters; i++)
	clustertab_refresh(i);
}

void
pmns_refresh(void)
{
    char *pmid, *next;
    I32 idsize;
    SV *metric;
    int sts;

    if (pmns)
	__pmFreePMNS(pmns);

    if ((sts = __pmNewPMNS(&pmns)) < 0)
	croak("failed to create namespace root: %s", pmErrStr(sts));

    hv_iterinit(metric_names);
    while ((metric = hv_iternextsv(metric_names, &pmid, &idsize)) != NULL) {
	unsigned int domain, cluster, item, id;

	domain = strtoul(pmid, &next, 10);
	cluster = strtoul(next+1, &next, 10);
	item = strtoul(next+1, &next, 10);
	id = pmid_build(domain, cluster, item);
	if ((sts = __pmAddPMNSNode(pmns, id, SvPV_nolen(metric))) < 0)
	    croak("failed to add metric %s(%s) to namespace: %s",
		SvPV_nolen(metric), pmIDStr(id), pmErrStr(sts));
    }

    pmdaTreeRebuildHash(pmns, mtab_size); /* for reverse (pmid->name) lookups */
    need_refresh = 0;
}

int
pmns_desc(pmID pmid, pmDesc *desc, pmdaExt *ep)
{
    if (need_refresh)
	pmns_refresh();
    return pmdaDesc(pmid, desc, ep);
}

int
pmns_pmid(const char *name, pmID *pmid, pmdaExt *pmda)
{
    if (need_refresh)
	pmns_refresh();
    return pmdaTreePMID(pmns, name, pmid);
}

int
pmns_name(pmID pmid, char ***nameset, pmdaExt *pmda)
{
    if (need_refresh)
	pmns_refresh();
    return pmdaTreeName(pmns, pmid, nameset);
}

int
pmns_children(const char *name, int traverse, char ***kids, int **sts, pmdaExt *pmda)
{
    if (need_refresh)
	pmns_refresh();
    return pmdaTreeChildren(pmns, name, traverse, kids, sts);
}

void
pmns_write(void)
{
    __pmnsNode *node;
    int root = strcmp(getenv("PCP_PERL_PMNS"), "root") == 0;
    char *prefix = root ? "\t" : "";

    pmns_refresh();

    if (root)
	printf("root {\n");
    for (node = pmns->root->first; node != NULL; node = node->next)
	printf("%s%s\t%u:*:*\n", prefix, node->name, dispatch.domain);
    if (root)
	printf("}\n");
}

void
domain_write(void)
{
    char name[512] = { 0 };
    int i, len = strlen(pmProgname);

    if (len >= sizeof(name) - 1)
	len = sizeof(name) - 2;
    for (i = 0; i < len; i++)
	name[i] = toupper(pmProgname[i]);
    printf("#define %s %u\n", name, dispatch.domain);
}

void
prefetch(int numpmid, pmID *pmidlist, pmResult **rp, pmdaExt *pmda)
{
    dSP;
    ENTER;
    SAVETMPS;
    PUSHMARK(sp);
    PUTBACK;

    perl_call_sv(fetch_func, G_VOID|G_NOARGS);

    SPAGAIN;
    PUTBACK;
    FREETMPS;
    LEAVE;
}

int
fetch(int numpmid, pmID *pmidlist, pmResult **rp, pmdaExt *pmda)
{
    int sts;

    if (need_refresh)
	pmns_refresh();
    if (fetch_func)
	prefetch(numpmid, pmidlist, rp, pmda);
    if (refresh_func)
	refresh(numpmid, pmidlist);
    sts = pmdaFetch(numpmid, pmidlist, rp, pmda);
    return sts;
}

void
preinstance(pmInDom indom, int a, char *b, __pmInResult **rp, pmdaExt *pmda)
{
    dSP;
    ENTER;
    SAVETMPS;
    PUSHMARK(sp);
    XPUSHs(sv_2mortal(newSVuv(indom)));
    PUTBACK;

    perl_call_sv(instance_func, G_VOID);

    SPAGAIN;
    PUTBACK;
    FREETMPS;
    LEAVE;
}

int
instance(pmInDom indom, int a, char *b, __pmInResult **rp, pmdaExt *pmda)
{
    if (need_refresh)
	pmns_refresh();
    if (instance_func)
	preinstance(indom, a, b, rp, pmda);
    return pmdaInstance(indom, a, b, rp, pmda);
}

void
timer_callback(int afid, void *data)
{
    dSP;
    ENTER;
    SAVETMPS;
    PUSHMARK(sp);
    XPUSHs(sv_2mortal(newSViv(local_timer_get_cookie(afid))));
    PUTBACK;

    perl_call_sv(local_timer_get_callback(afid), G_VOID);

    SPAGAIN;
    PUTBACK;
    FREETMPS;
    LEAVE;
}

void
input_callback(SV *input_cb_func, int data, char *string)
{
    dSP;
    ENTER;
    SAVETMPS;
    PUSHMARK(sp);
    XPUSHs(sv_2mortal(newSViv(data)));
    XPUSHs(sv_2mortal(newSVpv(string,0)));
    PUTBACK;

    perl_call_sv(input_cb_func, G_VOID);

    SPAGAIN;
    PUTBACK;
    FREETMPS;
    LEAVE;
}

int
fetch_callback(pmdaMetric *metric, unsigned int inst, pmAtomValue *atom)
{
    dSP;
    __pmID_int	*pmid;
    int		sts;
    STRLEN	n_a;	/* required by older Perl versions, used in POPpx */

    ENTER;
    SAVETMPS;	/* allows us to tidy our perl stack changes later */

    (void)n_a;
    pmid = (__pmID_int *) &metric->m_desc.pmid;

    PUSHMARK(sp);
    XPUSHs(sv_2mortal(newSVuv(pmid->cluster)));
    XPUSHs(sv_2mortal(newSVuv(pmid->item)));
    XPUSHs(sv_2mortal(newSVuv(inst)));
    PUTBACK;

    sts = perl_call_sv(fetch_cb_func, G_ARRAY);
    SPAGAIN;	/* refresh local perl stack pointer after call */
    if (sts != 2) {
	croak("fetch CB error (returned %d values, expected 2)", sts); 
	sts = -EINVAL;
	goto fetch_end;
    }
    sts = POPi;		/* pop function return status */
    if (sts < 0) {
	goto fetch_end;
    }
    else if (sts == 0) {
	sts = POPi;
	goto fetch_end;
    }

    sts = PMDA_FETCH_STATIC;
    switch (metric->m_desc.type) {	/* pop result value */
	case PM_TYPE_32:	atom->l = POPi; break;
	case PM_TYPE_U32:	atom->ul = POPi; break;
	case PM_TYPE_64:	atom->ll = POPl; break;
	case PM_TYPE_U64:	atom->ull = POPl; break;
	case PM_TYPE_FLOAT:	atom->f = POPn; break;
	case PM_TYPE_DOUBLE:	atom->d = POPn; break;
	case PM_TYPE_STRING:	{
	    atom->cp = strdup(POPpx);
	    sts = PMDA_FETCH_DYNAMIC;
	    break;
	}
    }

fetch_end:
    PUTBACK;
    FREETMPS;
    LEAVE;	/* fix up the perl stack, freeing anything we created */
    return sts;
}

int
store_callback(__pmID_int *pmid, unsigned int inst, pmAtomValue av, int type)
{
    dSP;
    int sts;
    ENTER;
    SAVETMPS;
    PUSHMARK(sp);
    XPUSHs(sv_2mortal(newSVuv(pmid->cluster)));
    XPUSHs(sv_2mortal(newSVuv(pmid->item)));
    XPUSHs(sv_2mortal(newSVuv(inst)));
    switch (type) {
	case PM_TYPE_32:     XPUSHs(sv_2mortal(newSViv(av.l))); break;
	case PM_TYPE_U32:    XPUSHs(sv_2mortal(newSVuv(av.ul))); break;
	case PM_TYPE_64:     XPUSHs(sv_2mortal(newSVuv(av.ll))); break;
	case PM_TYPE_U64:    XPUSHs(sv_2mortal(newSVuv(av.ull))); break;
	case PM_TYPE_FLOAT:  XPUSHs(sv_2mortal(newSVnv(av.f))); break;
	case PM_TYPE_DOUBLE: XPUSHs(sv_2mortal(newSVnv(av.d))); break;
	case PM_TYPE_STRING: XPUSHs(sv_2mortal(newSVpv(av.cp,0)));break;
    }
    PUTBACK;

    sts = perl_call_sv(store_cb_func, G_SCALAR);
    SPAGAIN;	/* refresh local perl stack pointer after call */
    if (sts != 1) {
	croak("store CB error (returned %d values, expected 1)", sts); 
	sts = -EINVAL;
	goto store_end;
    }
    sts = POPi;				/* pop function return status */

store_end:
    PUTBACK;
    FREETMPS;
    LEAVE;	/* fix up the perl stack, freeing anything we created */
    return sts;
}

int
store(pmResult *result, pmdaExt *pmda)
{
    int		i, j;
    int		type;
    int		sts;
    pmAtomValue	av;
    pmValueSet	*vsp;
    __pmID_int	*pmid;

    if (need_refresh)
	pmns_refresh();

    for (i = 0; i < result->numpmid; i++) {
	vsp = result->vset[i];
	pmid = (__pmID_int *)&vsp->pmid;

	/* need to find the type associated with this PMID */
	for (j = 0; j < mtab_size; j++)
	    if (metrictab[j].m_desc.pmid == *(pmID *)pmid)
		break;
	if (j == mtab_size)
	    return PM_ERR_PMID;
	type = metrictab[j].m_desc.type;

	for (j = 0; j < vsp->numval; j++) {
	    sts = pmExtractValue(vsp->valfmt, &vsp->vlist[j],type, &av, type);
	    if (sts < 0)
		return sts;
	    sts = store_callback(pmid, vsp->vlist[j].inst, av, type);
	    if (sts < 0)
		return sts;
	}
    }
    return 0;
}

int
text(int ident, int type, char **buffer, pmdaExt *pmda)
{
    const char *hash;
    int size;
    SV **sv;

    if (need_refresh)
	pmns_refresh();

    if ((type & PM_TEXT_PMID) == PM_TEXT_PMID) {
	hash = pmIDStr((pmID)ident);
	size = strlen(hash);
	if (type & PM_TEXT_ONELINE)
	    sv = hv_fetch(metric_oneline, hash, size, 0);
	else
	    sv = hv_fetch(metric_helptext, hash, size, 0);
    }
    else {
	hash = pmInDomStr((pmInDom)ident);
	size = strlen(hash);
	if (type & PM_TEXT_ONELINE)
	    sv = hv_fetch(indom_oneline, hash, size, 0);
	else
	    sv = hv_fetch(indom_helptext, hash, size, 0);
    }

    if (sv && (*sv))
	*buffer = SvPV_nolen(*sv);
    return (*buffer == NULL) ? PM_ERR_TEXT : 0;
}

/*
 * Converts Perl list ref like [a => 'foo', b => 'boo'] into an indom
 */
static int
list_to_indom(SV *list, pmdaInstid **set)
{
    int	i, len;
    SV	**id;
    SV	**name;
    AV	*ilist = (AV *) SvRV(list);
    pmdaInstid *instances;

    if (SvTYPE((SV *)ilist) != SVt_PVAV) {
	warn("final argument is not an array reference");
	return -1;
    }
    if ((len = av_len(ilist)) == -1) {	/* empty */
	*set = NULL;
	return 0;
    }
    if (len++ % 2 == 0) {
	warn("invalid instance list (length must be a multiple of 2)");
	return -1;
    }

    len /= 2;
    instances = (pmdaInstid *) calloc(len, sizeof(pmdaInstid));
    if (instances == NULL) {
	warn("insufficient memory for instance array");
	return -1;
    }
    for (i = 0; i < len; i++) {
	id = av_fetch(ilist,i*2,0);
	name = av_fetch(ilist,i*2+1,0);
	instances[i].i_inst = SvIV(*id);
	instances[i].i_name = strdup(SvPV_nolen(*name));
	if (instances[i].i_name == NULL) {
	    warn("insufficient memory for instance array names");
	    return -1;
	}
    }
    *set = instances;
    return len;
}


#line 526 "PMDA.c"
XS(XS_PCP__PMDA_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_new)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::new(CLASS, name, domain)");
    {
	char *	CLASS = (char *)SvPV_nolen(ST(0));
	char *	name = (char *)SvPV_nolen(ST(1));
	int	domain = (int)SvIV(ST(2));
#line 525 "PMDA.xs"
	int	sep;
	char *	p;
	char *	logfile;
	char *	pmdaname;
	char	helpfile[256];
#line 543 "PMDA.c"
	pmdaInterface *	RETVAL;
#line 531 "PMDA.xs"
	pmProgname = name;
	RETVAL = &dispatch;
	logfile = local_strdup_suffix(name, ".log");
	pmdaname = local_strdup_prefix("pmda", name);
	__pmSetProgname(pmdaname);
	sep = __pmPathSeparator();
	if ((p = getenv("PCP_PERL_DEBUG")) != NULL)
	    if ((pmDebug = __pmParseDebug(p)) < 0)
		pmDebug = 0;
#ifndef IS_MINGW
	setsid();
#endif
	atexit(&local_atexit);
	snprintf(helpfile, sizeof(helpfile), "%s%c%s%c" "help",
			pmGetConfig("PCP_PMDAS_DIR"), sep, name, sep);
	if (access(helpfile, R_OK) != 0) {
	    pmdaDaemon(&dispatch, PMDA_INTERFACE_5, pmdaname, domain,
			logfile, NULL);
	    dispatch.version.four.text = text;
	}
	else {
	    pmdaDaemon(&dispatch, PMDA_INTERFACE_5, pmdaname, domain,
			logfile, helpfile);
	}
	dispatch.version.four.fetch = fetch;
	dispatch.version.four.instance = instance;
	dispatch.version.four.desc = pmns_desc;
	dispatch.version.four.pmid = pmns_pmid;
	dispatch.version.four.name = pmns_name;
	dispatch.version.four.children = pmns_children;

	if (!getenv("PCP_PERL_PMNS") && !getenv("PCP_PERL_DOMAIN")) {
	    pmdaOpenLog(&dispatch);
	}
	metric_names = newHV();
	metric_oneline = newHV();
	metric_helptext = newHV();
	indom_helptext = newHV();
	indom_oneline = newHV();
#line 585 "PMDA.c"
	ST(0) = sv_newmortal();
        sv_setref_pv( ST(0), CLASS, (void*)RETVAL );


    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_pmda_pmid); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_pmda_pmid)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::pmda_pmid(cluster, item)");
    {
	unsigned int	cluster = (unsigned int)SvUV(ST(0));
	unsigned int	item = (unsigned int)SvUV(ST(1));
	int	RETVAL;
	dXSTARG;
#line 578 "PMDA.xs"
	RETVAL = pmid_build(dispatch.domain, cluster, item);
#line 607 "PMDA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_pmda_pmid_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_pmda_pmid_name)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::pmda_pmid_name(cluster, item)");
    {
	unsigned int	cluster = (unsigned int)SvUV(ST(0));
	unsigned int	item = (unsigned int)SvUV(ST(1));
#line 587 "PMDA.xs"
	const char	*name;
	SV		**rval;
#line 625 "PMDA.c"
	SV *	RETVAL;
#line 590 "PMDA.xs"
	name = pmIDStr(pmid_build(dispatch.domain, cluster, item));
	rval = hv_fetch(metric_names, name, strlen(name), 0);
	if (!rval || !(*rval))
	    XSRETURN_UNDEF;
	RETVAL = newSVsv(*rval);
#line 633 "PMDA.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_pmda_pmid_text); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_pmda_pmid_text)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::pmda_pmid_text(cluster, item)");
    {
	unsigned int	cluster = (unsigned int)SvUV(ST(0));
	unsigned int	item = (unsigned int)SvUV(ST(1));
#line 603 "PMDA.xs"
	const char	*name;
	SV		**rval;
#line 652 "PMDA.c"
	SV *	RETVAL;
#line 606 "PMDA.xs"
	name = pmIDStr(pmid_build(dispatch.domain, cluster, item));
	rval = hv_fetch(metric_oneline, name, strlen(name), 0);
	if (!rval || !(*rval))
	    XSRETURN_UNDEF;
	RETVAL = newSVsv(*rval);
#line 660 "PMDA.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_pmda_inst_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_pmda_inst_name)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::pmda_inst_name(indom, instance)");
    {
	unsigned int	indom = (unsigned int)SvUV(ST(0));
	int	instance = (int)SvIV(ST(1));
#line 619 "PMDA.xs"
	pmdaInstid	*instp;
	int		i, instc;
#line 679 "PMDA.c"
	SV *	RETVAL;
#line 622 "PMDA.xs"
	indom = pmInDom_build(dispatch.domain, indom);
	for (i = 0; i < itab_size; i++)
	    if (indomtab[i].it_indom == indom)
		break;
	if (i == itab_size)
	    XSRETURN_UNDEF;
	instp = indomtab[i].it_set;
	instc = indomtab[i].it_numinst;

	/* Optimistic (fast) direct lookup first, then iterate */
	i = instance;
	if (i > instc || i < 0 || instance != instp[i].i_inst) {
	    for (i = 0; i < instc; i++)
		if (instance == instp[i].i_inst)
		    break;
	    if (i == instc)
		XSRETURN_UNDEF;
	}
	RETVAL = newSVpv(instp[i].i_name,0);
#line 701 "PMDA.c"
	ST(0) = RETVAL;
	sv_2mortal(ST(0));
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_pmda_units); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_pmda_units)
{
    dXSARGS;
    if (items != 6)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::pmda_units(dim_space, dim_time, dim_count, scale_space, scale_time, scale_count)");
    {
	unsigned int	dim_space = (unsigned int)SvUV(ST(0));
	unsigned int	dim_time = (unsigned int)SvUV(ST(1));
	unsigned int	dim_count = (unsigned int)SvUV(ST(2));
	unsigned int	scale_space = (unsigned int)SvUV(ST(3));
	unsigned int	scale_time = (unsigned int)SvUV(ST(4));
	unsigned int	scale_count = (unsigned int)SvUV(ST(5));
#line 653 "PMDA.xs"
	pmUnits	units;
#line 723 "PMDA.c"
	int	RETVAL;
	dXSTARG;
#line 655 "PMDA.xs"
	units.pad = 0;
	units.dimSpace = dim_space;	units.scaleSpace = scale_space;
	units.dimTime = dim_time;	units.scaleTime = scale_time;
	units.dimCount = dim_count;	units.scaleCount = scale_count;
	RETVAL = *(int *)(&units);
#line 732 "PMDA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_pmda_config); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_pmda_config)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::pmda_config(name)");
    {
	char *	name = (char *)SvPV_nolen(ST(0));
	char *	RETVAL;
	dXSTARG;
#line 667 "PMDA.xs"
	RETVAL = pmGetConfig(name);
	if (!RETVAL)
	    XSRETURN_UNDEF;
#line 752 "PMDA.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_pmda_uptime); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_pmda_uptime)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::pmda_uptime(now)");
    {
	int	now = (int)SvIV(ST(0));
#line 677 "PMDA.xs"
	static char s[32];
	size_t sz = sizeof(s);
	int days, hours, mins, secs;
#line 770 "PMDA.c"
	char *	RETVAL;
	dXSTARG;
#line 681 "PMDA.xs"
	days = now / (60 * 60 * 24);
	now %= (60 * 60 * 24);
	hours = now / (60 * 60);
	now %= (60 * 60);
	mins = now / 60;
	now %= 60;
	secs = now;

	if (days > 1)
	    snprintf(s, sz, "%ddays %02d:%02d:%02d", days, hours, mins, secs);
	else if (days == 1)
	    snprintf(s, sz, "%dday %02d:%02d:%02d", days, hours, mins, secs);
	else
	    snprintf(s, sz, "%02d:%02d:%02d", hours, mins, secs);
	RETVAL = s;
#line 789 "PMDA.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_pmda_long); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_pmda_long)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::pmda_long()");
    {
	int	RETVAL;
	dXSTARG;
#line 702 "PMDA.xs"
	RETVAL = (sizeof(long) == 4) ? PM_TYPE_32 : PM_TYPE_64;
#line 806 "PMDA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_pmda_ulong); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_pmda_ulong)
{
    dXSARGS;
    if (items != 0)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::pmda_ulong()");
    {
	int	RETVAL;
	dXSTARG;
#line 709 "PMDA.xs"
	RETVAL = (sizeof(unsigned long) == 4) ? PM_TYPE_32 : PM_TYPE_64;
#line 823 "PMDA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_error)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::error(self, message)");
    {
	pmdaInterface *	self;
	char *	message = (char *)SvPV_nolen(ST(1));

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::error() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 719 "PMDA.xs"
	__pmNotifyErr(LOG_ERR, "%s", message);
#line 847 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_PCP__PMDA_set_user); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_set_user)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::set_user(self, username)");
    {
	pmdaInterface *	self;
	char *	username = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::set_user() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 726 "PMDA.xs"
	RETVAL = local_user(username);
#line 872 "PMDA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_set_fetch); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_set_fetch)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::set_fetch(self, function)");
    {
	pmdaInterface *	self;
	SV *	function = ST(1);

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::set_fetch() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 735 "PMDA.xs"
	if (function != (SV *)NULL) {
	    fetch_func = newSVsv(function);
	}
#line 898 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_PCP__PMDA_set_refresh); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_set_refresh)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::set_refresh(self, function)");
    {
	pmdaInterface *	self;
	SV *	function = ST(1);

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::set_refresh() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 744 "PMDA.xs"
	if (function != (SV *)NULL) {
	    refresh_func = newSVsv(function);
	}
#line 923 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_PCP__PMDA_set_instance); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_set_instance)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::set_instance(self, function)");
    {
	pmdaInterface *	self;
	SV *	function = ST(1);

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::set_instance() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 753 "PMDA.xs"
	if (function != (SV *)NULL) {
	    instance_func = newSVsv(function);
	}
#line 948 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_PCP__PMDA_set_store_callback); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_set_store_callback)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::set_store_callback(self, cb_function)");
    {
	pmdaInterface *	self;
	SV *	cb_function = ST(1);

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::set_store_callback() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 762 "PMDA.xs"
	if (cb_function != (SV *)NULL) {
	    store_cb_func = newSVsv(cb_function);
	    self->version.four.store = store;
	}
#line 974 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_PCP__PMDA_set_fetch_callback); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_set_fetch_callback)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::set_fetch_callback(self, cb_function)");
    {
	pmdaInterface *	self;
	SV *	cb_function = ST(1);

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::set_fetch_callback() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 772 "PMDA.xs"
	if (cb_function != (SV *)NULL) {
	    fetch_cb_func = newSVsv(cb_function);
	    pmdaSetFetchCallBack(self, fetch_callback);
	}
#line 1000 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_PCP__PMDA_set_inet_socket); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_set_inet_socket)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::set_inet_socket(self, port)");
    {
	pmdaInterface *	self;
	int	port = (int)SvIV(ST(1));

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::set_inet_socket() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 782 "PMDA.xs"
	self->version.four.ext->e_io = pmdaInet;
	self->version.four.ext->e_port = port;
#line 1024 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_PCP__PMDA_set_unix_socket); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_set_unix_socket)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::set_unix_socket(self, socket_name)");
    {
	pmdaInterface *	self;
	char *	socket_name = (char *)SvPV_nolen(ST(1));

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::set_unix_socket() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 790 "PMDA.xs"
	self->version.four.ext->e_io = pmdaUnix;
	self->version.four.ext->e_sockname = socket_name;
#line 1048 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_PCP__PMDA_clear_metrics); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_clear_metrics)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::clear_metrics(self)");
    {
	pmdaInterface *	self;

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::clear_metrics() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 797 "PMDA.xs"
	need_refresh = 1;
	if (clustertab)
	    free(clustertab);
	ctab_size = 0;
	if (metrictab)
	    free(metrictab);
	mtab_size = 0;
	clearHV(metric_names);
	clearHV(metric_oneline);
	clearHV(metric_helptext);
#line 1079 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_PCP__PMDA_add_metric); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_add_metric)
{
    dXSARGS;
    if (items != 9)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::add_metric(self, pmid, type, indom, sem, units, name, help, longhelp)");
    {
	pmdaInterface *	self;
	int	pmid = (int)SvIV(ST(1));
	int	type = (int)SvIV(ST(2));
	int	indom = (int)SvIV(ST(3));
	int	sem = (int)SvIV(ST(4));
	int	units = (int)SvIV(ST(5));
	char *	name = (char *)SvPV_nolen(ST(6));
	char *	help = (char *)SvPV_nolen(ST(7));
	char *	longhelp = (char *)SvPV_nolen(ST(8));
#line 820 "PMDA.xs"
	pmdaMetric * p;
	__pmID_int * pmidp;
	const char * hash;
	int          size;
#line 1105 "PMDA.c"

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::add_metric() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 825 "PMDA.xs"
	(void)self;
	need_refresh = 1;
	pmidp = (__pmID_int *)&pmid;
	if (!clustertab_lookup(pmidp->cluster)) {
	    size = sizeof(int) * (ctab_size + 1);
	    clustertab = (int *)realloc(clustertab, size);
	    if (clustertab)
		clustertab[ctab_size++] = pmidp->cluster;
	    else {
		warn("unable to allocate memory for cluster table");
		ctab_size = 0;
		XSRETURN_UNDEF;
	    }
	}

	size = sizeof(pmdaMetric) * (mtab_size + 1);
	metrictab = (pmdaMetric *)realloc(metrictab, size);
	if (metrictab == NULL) {
	    warn("unable to allocate memory for metric table");
	    mtab_size = 0;
	    XSRETURN_UNDEF;
	}

	p = metrictab + mtab_size++;
	p->m_user = NULL;	p->m_desc.pmid = *(pmID *)&pmid;
	p->m_desc.type = type;	p->m_desc.indom = *(pmInDom *)&indom;
	p->m_desc.sem = sem;	p->m_desc.units = *(pmUnits *)&units;

	hash = pmIDStr(pmid);
	size = strlen(hash);
	hv_store(metric_names, hash, size, newSVpv(name,0), 0);
	if (help)
	    hv_store(metric_oneline, hash, size, newSVpv(help,0), 0);
	if (longhelp)
	    hv_store(metric_helptext, hash, size, newSVpv(longhelp,0), 0);
#line 1149 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_PCP__PMDA_clear_indoms); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_clear_indoms)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::clear_indoms(self)");
    {
	pmdaInterface *	self;

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::clear_indoms() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 865 "PMDA.xs"
	if (indomtab)
	    free(indomtab);
	itab_size = 0;
	if (metrictab)
	    free(metrictab);
	mtab_size = 0;
	clearHV(indom_oneline);
	clearHV(indom_helptext);
#line 1178 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_PCP__PMDA_add_indom); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_add_indom)
{
    dXSARGS;
    if (items != 5)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::add_indom(self, indom, list, help, longhelp)");
    {
	pmdaInterface *	self;
	int	indom = (int)SvIV(ST(1));
	SV *	list = ST(2);
	char *	help = (char *)SvPV_nolen(ST(3));
	char *	longhelp = (char *)SvPV_nolen(ST(4));
#line 882 "PMDA.xs"
	pmdaIndom  * p;
	const char * hash;
	int          size;
#line 1199 "PMDA.c"
	int	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::add_indom() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 886 "PMDA.xs"
	(void)self;
	size = sizeof(pmdaIndom) * (itab_size + 1);
	indomtab = (pmdaIndom *)realloc(indomtab, size);
	if (indomtab == NULL) {
	    warn("unable to allocate memory for indom table");
	    itab_size = 0;
	    XSRETURN_UNDEF;
	}

	p = indomtab + itab_size;
	p->it_indom = *(pmInDom *)&indom;
	p->it_numinst = list_to_indom(list, &p->it_set);
	if (p->it_numinst == -1)
	    XSRETURN_UNDEF;
	else
	    RETVAL = itab_size++;	/* used in calls to replace_indom() */

	hash = pmInDomStr(indom);
	size = strlen(hash);
	if (help)
	    hv_store(indom_oneline, hash, size, newSVpv(help,0), 0);
	if (longhelp)
	    hv_store(indom_helptext, hash, size, newSVpv(longhelp,0), 0);
#line 1233 "PMDA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_replace_indom); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_replace_indom)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::replace_indom(self, index, list)");
    {
	pmdaInterface *	self;
	int	index = (int)SvIV(ST(1));
	SV *	list = ST(2);
#line 918 "PMDA.xs"
	pmdaIndom *	p;
	int		i;
#line 1252 "PMDA.c"
	int	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::replace_indom() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 921 "PMDA.xs"
	if (index >= itab_size || index < 0) {
	    warn("attempt to replace non-existent instance domain");
	    XSRETURN_UNDEF;
	}
	else {
	    p = indomtab + index;
	    if (p->it_set && p->it_numinst > 0) {
		for (i = 0; i < p->it_numinst; i++)
		    free(p->it_set[i].i_name);	/* list_to_indom strdup */
		free(p->it_set);	/* list_to_indom calloc */
	    }
	    p->it_numinst = list_to_indom(list, &p->it_set);
	    if (p->it_numinst == -1)
		XSRETURN_UNDEF;
	    else
		RETVAL = p->it_numinst;
	}
#line 1280 "PMDA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_add_timer); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_add_timer)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::add_timer(self, timeout, callback, data)");
    {
	pmdaInterface *	self;
	double	timeout = (double)SvNV(ST(1));
	SV *	callback = ST(2);
	int	data = (int)SvIV(ST(3));
	int	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::add_timer() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 948 "PMDA.xs"
	if (getenv("PCP_PERL_PMNS") || getenv("PCP_PERL_DOMAIN") || !callback)
	    XSRETURN_UNDEF;
	RETVAL = local_timer(timeout, newSVsv(callback), data);
#line 1310 "PMDA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_add_pipe); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_add_pipe)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::add_pipe(self, command, callback, data)");
    {
	pmdaInterface *	self;
	char *	command = (char *)SvPV_nolen(ST(1));
	SV *	callback = ST(2);
	int	data = (int)SvIV(ST(3));
	int	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::add_pipe() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 961 "PMDA.xs"
	if (getenv("PCP_PERL_PMNS") || getenv("PCP_PERL_DOMAIN") || !callback)
	    XSRETURN_UNDEF;
	RETVAL = local_pipe(command, newSVsv(callback), data);
#line 1340 "PMDA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_add_tail); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_add_tail)
{
    dXSARGS;
    if (items != 4)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::add_tail(self, filename, callback, data)");
    {
	pmdaInterface *	self;
	char *	filename = (char *)SvPV_nolen(ST(1));
	SV *	callback = ST(2);
	int	data = (int)SvIV(ST(3));
	int	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::add_tail() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 974 "PMDA.xs"
	if (getenv("PCP_PERL_PMNS") || getenv("PCP_PERL_DOMAIN") || !callback)
	    XSRETURN_UNDEF;
	RETVAL = local_tail(filename, newSVsv(callback), data);
#line 1370 "PMDA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_add_sock); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_add_sock)
{
    dXSARGS;
    if (items != 5)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::add_sock(self, hostname, port, callback, data)");
    {
	pmdaInterface *	self;
	char *	hostname = (char *)SvPV_nolen(ST(1));
	int	port = (int)SvIV(ST(2));
	SV *	callback = ST(3);
	int	data = (int)SvIV(ST(4));
	int	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::add_sock() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 988 "PMDA.xs"
	if (getenv("PCP_PERL_PMNS") || getenv("PCP_PERL_DOMAIN") || !callback)
	    XSRETURN_UNDEF;
	RETVAL = local_sock(hostname, port, newSVsv(callback), data);
#line 1401 "PMDA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_put_sock); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_put_sock)
{
    dXSARGS;
    if (items != 3)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::put_sock(self, id, output)");
    {
	pmdaInterface *	self;
	int	id = (int)SvIV(ST(1));
	char *	output = (char *)SvPV_nolen(ST(2));
	int	RETVAL;
	dXSTARG;

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::put_sock() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 1000 "PMDA.xs"
	RETVAL = write(local_files_get_descriptor(id), output, strlen(output));
#line 1428 "PMDA.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}

XS(XS_PCP__PMDA_log); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_log)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::log(self, message)");
    {
	pmdaInterface *	self;
	char *	message = (char *)SvPV_nolen(ST(1));

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::log() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 1009 "PMDA.xs"
	__pmNotifyErr(LOG_INFO, "%s", message);
#line 1452 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_PCP__PMDA_err); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_err)
{
    dXSARGS;
    if (items != 2)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::err(self, message)");
    {
	pmdaInterface *	self;
	char *	message = (char *)SvPV_nolen(ST(1));

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::err() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 1016 "PMDA.xs"
	__pmNotifyErr(LOG_ERR, "%s", message);
#line 1475 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_PCP__PMDA_run); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_run)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::run(self)");
    {
	pmdaInterface *	self;

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::run() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 1022 "PMDA.xs"
	if (getenv("PCP_PERL_PMNS") != NULL)
	    pmns_write();	/* generate ascii namespace */
	else if (getenv("PCP_PERL_DOMAIN") != NULL)
	    domain_write();	/* generate the domain header */
	else {		/* or normal operating mode ... */
	    pmns_refresh();
	    pmdaInit(self, indomtab, itab_size, metrictab, mtab_size);
	    pmdaConnect(self);
	    local_pmdaMain(self);
	}
#line 1506 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_PCP__PMDA_debug_metric); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_debug_metric)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::debug_metric(self)");
    {
	pmdaInterface *	self;
#line 1037 "PMDA.xs"
	int	i;
#line 1521 "PMDA.c"

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::debug_metric() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 1039 "PMDA.xs"
	/* NB: debugging only (used in test.pl to verify state) */
	fprintf(stderr, "metric table size = %d\n", mtab_size);
	for (i = 0; i < mtab_size; i++) {
	    fprintf(stderr, "metric idx = %d\n\tpmid = %s\n\ttype = %u\n"
			"\tindom= %d\n\tsem  = %u\n\tunits= %u\n",
		i, pmIDStr(metrictab[i].m_desc.pmid), metrictab[i].m_desc.type,
		(int)metrictab[i].m_desc.indom, metrictab[i].m_desc.sem,
		*(unsigned int *)&metrictab[i].m_desc.units);
	}
	(void)self;
#line 1540 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_PCP__PMDA_debug_indom); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_debug_indom)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::debug_indom(self)");
    {
	pmdaInterface *	self;
#line 1054 "PMDA.xs"
	int	i,j;
#line 1555 "PMDA.c"

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::debug_indom() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 1056 "PMDA.xs"
	/* NB: debugging only (used in test.pl to verify state) */
	fprintf(stderr, "indom table size = %d\n", itab_size);
	for (i = 0; i < itab_size; i++) {
	    fprintf(stderr, "indom idx = %d\n\tindom = %d\n"
			    "\tninst = %u\n\tiptr = 0x%p\n",
		    i, *(int *)&indomtab[i].it_indom, indomtab[i].it_numinst,
		    indomtab[i].it_set);
	    for (j = 0; j < indomtab[i].it_numinst; j++) {
		fprintf(stderr, "\t\tid=%d name=%s\n",
		    indomtab[i].it_set[j].i_inst, indomtab[i].it_set[j].i_name);
	    }
	}
	(void)self;
#line 1577 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

XS(XS_PCP__PMDA_debug_init); /* prototype to pass -Wmissing-prototypes */
XS(XS_PCP__PMDA_debug_init)
{
    dXSARGS;
    if (items != 1)
	Perl_croak(aTHX_ "Usage: PCP::PMDA::debug_init(self)");
    {
	pmdaInterface *	self;

	if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
		self = (pmdaInterface *)SvIV((SV *)SvRV(ST(0)));
	else {
		warn("PCP::PMDA::debug_init() -- self is not a blessed SV reference");
		XSRETURN_UNDEF;
	};
#line 1074 "PMDA.xs"
	/* NB: debugging only (used in test.pl to verify state) */
	pmdaInit(self, indomtab, itab_size, metrictab, mtab_size);
#line 1600 "PMDA.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_PCP__PMDA); /* prototype to pass -Wmissing-prototypes */
XS(boot_PCP__PMDA)
{
    dXSARGS;
    char* file = __FILE__;

    XS_VERSION_BOOTCHECK ;

        newXS("PCP::PMDA::new", XS_PCP__PMDA_new, file);
        newXS("PCP::PMDA::pmda_pmid", XS_PCP__PMDA_pmda_pmid, file);
        newXS("PCP::PMDA::pmda_pmid_name", XS_PCP__PMDA_pmda_pmid_name, file);
        newXS("PCP::PMDA::pmda_pmid_text", XS_PCP__PMDA_pmda_pmid_text, file);
        newXS("PCP::PMDA::pmda_inst_name", XS_PCP__PMDA_pmda_inst_name, file);
        newXS("PCP::PMDA::pmda_units", XS_PCP__PMDA_pmda_units, file);
        newXS("PCP::PMDA::pmda_config", XS_PCP__PMDA_pmda_config, file);
        newXS("PCP::PMDA::pmda_uptime", XS_PCP__PMDA_pmda_uptime, file);
        newXS("PCP::PMDA::pmda_long", XS_PCP__PMDA_pmda_long, file);
        newXS("PCP::PMDA::pmda_ulong", XS_PCP__PMDA_pmda_ulong, file);
        newXS("PCP::PMDA::error", XS_PCP__PMDA_error, file);
        newXS("PCP::PMDA::set_user", XS_PCP__PMDA_set_user, file);
        newXS("PCP::PMDA::set_fetch", XS_PCP__PMDA_set_fetch, file);
        newXS("PCP::PMDA::set_refresh", XS_PCP__PMDA_set_refresh, file);
        newXS("PCP::PMDA::set_instance", XS_PCP__PMDA_set_instance, file);
        newXS("PCP::PMDA::set_store_callback", XS_PCP__PMDA_set_store_callback, file);
        newXS("PCP::PMDA::set_fetch_callback", XS_PCP__PMDA_set_fetch_callback, file);
        newXS("PCP::PMDA::set_inet_socket", XS_PCP__PMDA_set_inet_socket, file);
        newXS("PCP::PMDA::set_unix_socket", XS_PCP__PMDA_set_unix_socket, file);
        newXS("PCP::PMDA::clear_metrics", XS_PCP__PMDA_clear_metrics, file);
        newXS("PCP::PMDA::add_metric", XS_PCP__PMDA_add_metric, file);
        newXS("PCP::PMDA::clear_indoms", XS_PCP__PMDA_clear_indoms, file);
        newXS("PCP::PMDA::add_indom", XS_PCP__PMDA_add_indom, file);
        newXS("PCP::PMDA::replace_indom", XS_PCP__PMDA_replace_indom, file);
        newXS("PCP::PMDA::add_timer", XS_PCP__PMDA_add_timer, file);
        newXS("PCP::PMDA::add_pipe", XS_PCP__PMDA_add_pipe, file);
        newXS("PCP::PMDA::add_tail", XS_PCP__PMDA_add_tail, file);
        newXS("PCP::PMDA::add_sock", XS_PCP__PMDA_add_sock, file);
        newXS("PCP::PMDA::put_sock", XS_PCP__PMDA_put_sock, file);
        newXS("PCP::PMDA::log", XS_PCP__PMDA_log, file);
        newXS("PCP::PMDA::err", XS_PCP__PMDA_err, file);
        newXS("PCP::PMDA::run", XS_PCP__PMDA_run, file);
        newXS("PCP::PMDA::debug_metric", XS_PCP__PMDA_debug_metric, file);
        newXS("PCP::PMDA::debug_indom", XS_PCP__PMDA_debug_indom, file);
        newXS("PCP::PMDA::debug_init", XS_PCP__PMDA_debug_init, file);
    XSRETURN_YES;
}

