/* A Bison parser, made by GNU Bison 1.875c.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     NUMBER2D = 258,
     NUMBER3D = 259,
     NUMBER = 260,
     NEGNUMBER = 261,
     FLAG = 262,
     NAME = 263,
     PATHNAME = 264,
     MACRO = 265,
     STRING = 266,
     COMMA = 267,
     EQUAL = 268,
     OPEN = 269,
     CLOSE = 270,
     DESC = 271,
     GETDESC = 272,
     FETCH = 273,
     INSTANCE = 274,
     PROFILE = 275,
     HELP = 276,
     WATCH = 277,
     DBG = 278,
     QUIT = 279,
     STATUS = 280,
     STORE = 281,
     INFO = 282,
     TIMER = 283,
     NAMESPACE = 284,
     WAIT = 285,
     PMNS_NAME = 286,
     PMNS_PMID = 287,
     PMNS_CHILDREN = 288,
     PMNS_TRAVERSE = 289,
     DSO = 290,
     PIPE = 291,
     SOCK = 292,
     ADD = 293,
     DEL = 294,
     ALL = 295,
     NONE = 296,
     INDOM = 297,
     ON = 298,
     OFF = 299,
     PLUS = 300,
     EOL = 301
   };
#endif
#define NUMBER2D 258
#define NUMBER3D 259
#define NUMBER 260
#define NEGNUMBER 261
#define FLAG 262
#define NAME 263
#define PATHNAME 264
#define MACRO 265
#define STRING 266
#define COMMA 267
#define EQUAL 268
#define OPEN 269
#define CLOSE 270
#define DESC 271
#define GETDESC 272
#define FETCH 273
#define INSTANCE 274
#define PROFILE 275
#define HELP 276
#define WATCH 277
#define DBG 278
#define QUIT 279
#define STATUS 280
#define STORE 281
#define INFO 282
#define TIMER 283
#define NAMESPACE 284
#define WAIT 285
#define PMNS_NAME 286
#define PMNS_PMID 287
#define PMNS_CHILDREN 288
#define PMNS_TRAVERSE 289
#define DSO 290
#define PIPE 291
#define SOCK 292
#define ADD 293
#define DEL 294
#define ALL 295
#define NONE 296
#define INDOM 297
#define ON 298
#define OFF 299
#define PLUS 300
#define EOL 301




/* Copy the first part of user declarations.  */
#line 19 "gram.y"

#include "./dbpmda.h"
#include "./lex.h"

extern int stmt_type;

static union {
    pmID	whole;
    __pmID_int	part;
} pmid;

static union {
    pmInDom		whole;
    __pmInDom_int	part;
} indom;


static int	sts;
static int	inst;
static char	*str;
static char	warnStr[80];

param_t	param;

/*
 * pmidp may contain a dynamic PMID ... if so, ask the PMDA to
 * translate name if possible
 */
static int
fix_dynamic_pmid(char *name, pmID *pmidp)
{
    int		sts;
    __pmPDU	*pb;
    extern int	outfd;
    extern int	infd;
    extern pmdaInterface	dispatch;

    if (((__pmID_int *)pmidp)->domain == DYNAMIC_PMID) {
	if (connmode == CONN_DSO) {
	    if (dispatch.comm.pmda_interface >= PMDA_INTERFACE_4) {
		sts = dispatch.version.four.pmid(name, pmidp, dispatch.version.four.ext);
		if (sts < 0) return sts;
	    }
	}
	else if (connmode == CONN_DAEMON) {
	    sts = __pmSendNameList(outfd, FROM_ANON, 1, &name, NULL);
	    if (sts < 0) return sts;
	    sts = __pmGetPDU(infd, ANY_SIZE, TIMEOUT_NEVER, &pb);
	    if (sts < 0) return sts;
	    if (sts == PDU_PMNS_IDS) {
		int	xsts;
		sts = __pmDecodeIDList(pb, 1, pmidp, &xsts);
		if (sts < 0) return sts;
		return xsts;
	    }
	    else if (sts == PDU_ERROR) {
		__pmDecodeError(pb, &sts);
		return sts;
	    }
	}
    }
    return 0;
}




/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
#line 86 "gram.y"
typedef union YYSTYPE {
	char		*y_str;
	int		y_num;
	twodot_num      y_2num;
	threedot_num    y_3num;
	} YYSTYPE;
/* Line 191 of yacc.c.  */
#line 242 "gram.tab.c"
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 254 "gram.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

# ifndef YYFREE
#  define YYFREE free
# endif
# ifndef YYMALLOC
#  define YYMALLOC malloc
# endif

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   define YYSTACK_ALLOC alloca
#  endif
# else
#  if defined (alloca) || defined (_ALLOCA_H)
#   define YYSTACK_ALLOC alloca
#  else
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (defined (YYSTYPE_IS_TRIVIAL) && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined (__GNUC__) && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  101
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   192

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  47
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  11
/* YYNRULES -- Number of rules. */
#define YYNRULES  94
/* YYNRULES -- Number of states. */
#define YYNSTATES  173

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   301

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     6,    13,    18,    22,    25,    28,    32,
      35,    39,    42,    47,    50,    54,    59,    62,    66,    71,
      76,    79,    84,    89,    95,   101,   104,   108,   111,   115,
     118,   122,   125,   129,   132,   136,   140,   143,   147,   151,
     155,   159,   163,   167,   171,   175,   179,   183,   187,   191,
     195,   199,   203,   207,   211,   215,   219,   223,   226,   229,
     233,   237,   241,   244,   247,   251,   255,   258,   262,   266,
     269,   273,   275,   276,   278,   280,   282,   283,   285,   287,
     289,   291,   293,   295,   297,   299,   301,   304,   308,   309,
     311,   313,   315,   317,   320
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const yysigned_char yyrhs[] =
{
      48,     0,    -1,    14,    46,    -1,    14,    35,    49,     8,
      50,    46,    -1,    14,    36,    49,    55,    -1,    14,    37,
      49,    -1,    15,    46,    -1,    16,    46,    -1,    16,    51,
      46,    -1,    18,    46,    -1,    18,    54,    46,    -1,    26,
      46,    -1,    26,    51,    11,    46,    -1,    27,    46,    -1,
      27,    51,    46,    -1,    27,    42,    52,    46,    -1,    19,
      46,    -1,    19,    52,    46,    -1,    19,    52,     5,    46,
      -1,    19,    52,    56,    46,    -1,    20,    46,    -1,    20,
      52,    40,    46,    -1,    20,    52,    41,    46,    -1,    20,
      52,    38,     5,    46,    -1,    20,    52,    39,     5,    46,
      -1,    22,    46,    -1,    22,    49,    46,    -1,    31,    46,
      -1,    31,    53,    46,    -1,    32,    46,    -1,    32,     8,
      46,    -1,    33,    46,    -1,    33,     8,    46,    -1,    34,
      46,    -1,    34,     8,    46,    -1,    29,    49,    46,    -1,
      21,    46,    -1,    21,    15,    46,    -1,    21,    23,    46,
      -1,    21,    16,    46,    -1,    21,    18,    46,    -1,    21,
      17,    46,    -1,    21,    27,    46,    -1,    21,    19,    46,
      -1,    21,    29,    46,    -1,    21,    14,    46,    -1,    21,
      33,    46,    -1,    21,    31,    46,    -1,    21,    32,    46,
      -1,    21,    34,    46,    -1,    21,    20,    46,    -1,    21,
      24,    46,    -1,    21,    25,    46,    -1,    21,    26,    46,
      -1,    21,    28,    46,    -1,    21,    30,    46,    -1,    21,
      22,    46,    -1,    24,    46,    -1,    23,    46,    -1,    23,
      40,    46,    -1,    23,    41,    46,    -1,    23,    57,    46,
      -1,    25,    46,    -1,    28,    46,    -1,    28,    43,    46,
      -1,    28,    44,    46,    -1,    17,    46,    -1,    17,    43,
      46,    -1,    17,    44,    46,    -1,    30,    46,    -1,    30,
       5,    46,    -1,    46,    -1,    -1,     8,    -1,     9,    -1,
       5,    -1,    -1,     5,    -1,     3,    -1,     4,    -1,     8,
      -1,     5,    -1,     6,    -1,     3,    -1,     4,    -1,    51,
      -1,    54,    51,    -1,    54,    12,    51,    -1,    -1,    11,
      -1,     8,    -1,     5,    -1,     8,    -1,     5,    57,    -1,
       8,    57,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,   132,   132,   136,   140,   144,   148,   151,   155,   159,
     163,   166,   170,   175,   179,   184,   189,   193,   199,   205,
     211,   215,   225,   235,   246,   257,   261,   265,   269,   273,
     277,   281,   285,   289,   293,   297,   302,   306,   310,   314,
     318,   322,   326,   330,   334,   338,   342,   346,   350,   354,
     358,   362,   366,   370,   374,   378,   382,   387,   388,   392,
     396,   400,   404,   407,   411,   414,   417,   421,   424,   427,
     431,   434,   435,   445,   446,   449,   450,   453,   465,   479,
     494,   509,   513,   517,   525,   534,   535,   536,   540,   543,
     544,   547,   548,   557,   558
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "NUMBER2D", "NUMBER3D", "NUMBER",
  "NEGNUMBER", "FLAG", "NAME", "PATHNAME", "MACRO", "STRING", "COMMA",
  "EQUAL", "OPEN", "CLOSE", "DESC", "GETDESC", "FETCH", "INSTANCE",
  "PROFILE", "HELP", "WATCH", "DBG", "QUIT", "STATUS", "STORE", "INFO",
  "TIMER", "NAMESPACE", "WAIT", "PMNS_NAME", "PMNS_PMID", "PMNS_CHILDREN",
  "PMNS_TRAVERSE", "DSO", "PIPE", "SOCK", "ADD", "DEL", "ALL", "NONE",
  "INDOM", "ON", "OFF", "PLUS", "EOL", "$accept", "stmt", "fname",
  "optdomain", "metric", "indom", "raw_pmid", "metriclist", "arglist",
  "inst", "debug", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,    47,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    48,    48,    48,    48,    48,    48,    48,
      48,    48,    48,    49,    49,    50,    50,    51,    51,    51,
      51,    52,    52,    52,    53,    54,    54,    54,    55,    56,
      56,    57,    57,    57,    57
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     2,     6,     4,     3,     2,     2,     3,     2,
       3,     2,     4,     2,     3,     4,     2,     3,     4,     4,
       2,     4,     4,     5,     5,     2,     3,     2,     3,     2,
       3,     2,     3,     2,     3,     3,     2,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     3,     2,     2,     3,
       3,     3,     2,     2,     3,     3,     2,     3,     3,     2,
       3,     1,     0,     1,     1,     1,     0,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     2,     3,     0,     1,
       1,     1,     1,     2,     2
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned char yydefact[] =
{
      72,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    71,     0,     0,     0,     0,     2,     6,    78,
      79,    77,    80,     7,     0,     0,     0,    66,     9,    85,
       0,    83,    81,    82,    16,     0,    20,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    36,    73,
      74,    25,     0,    91,    92,     0,     0,    58,     0,    57,
      62,    11,     0,     0,    13,     0,     0,     0,    63,     0,
       0,    69,    84,    27,     0,     0,    29,     0,    31,     0,
      33,     1,     0,    88,     5,     8,    67,    68,     0,    10,
      86,     0,    90,    89,    17,     0,     0,     0,     0,     0,
      45,    37,    39,    41,    40,    43,    50,    56,    38,    51,
      52,    53,    42,    54,    44,    55,    47,    48,    46,    49,
      26,    93,    94,    59,    60,    61,     0,     0,    14,    64,
      65,    35,    70,    28,    30,    32,    34,    76,     4,    87,
      18,    19,     0,     0,    21,    22,    12,    15,    75,     0,
      23,    24,     3
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,    23,    72,   169,    34,    45,    94,    40,   158,   115,
      78
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -33
static const short yypact[] =
{
      90,    38,   -32,    13,    18,    19,    33,    37,   115,    17,
      26,    -9,    30,    25,    -1,    54,    60,     8,     1,    -2,
      12,    24,   -33,    82,    60,    60,    60,   -33,   -33,   -33,
     -33,   -33,   -33,   -33,    39,    40,    55,   -33,   -33,   -33,
       7,   -33,   -33,   -33,   -33,    41,   -33,    53,    56,    79,
      80,    81,   104,   105,   106,   107,   108,   109,   110,   111,
     112,   113,   114,   116,   117,   118,   119,   120,   -33,   -33,
     -33,   -33,   121,    73,    73,   122,   123,   -33,   124,   -33,
     -33,   -33,    88,    45,   -33,   125,   126,   127,   -33,   128,
     129,   -33,   -33,   -33,   130,   131,   -33,   132,   -33,   133,
     -33,   -33,   172,   -33,   -33,   -33,   -33,   -33,    52,   -33,
     -33,   135,   -33,   -33,   -33,   136,   178,   179,   139,   140,
     -33,   -33,   -33,   -33,   -33,   -33,   -33,   -33,   -33,   -33,
     -33,   -33,   -33,   -33,   -33,   -33,   -33,   -33,   -33,   -33,
     -33,   -33,   -33,   -33,   -33,   -33,   141,   142,   -33,   -33,
     -33,   -33,   -33,   -33,   -33,   -33,   -33,   184,   -33,   -33,
     -33,   -33,   144,   145,   -33,   -33,   -33,   -33,   -33,   146,
     -33,   -33,   -33
};

/* YYPGOTO[NTERM-NUM].  */
static const yysigned_char yypgoto[] =
{
     -33,   -33,    64,   -33,    -5,    -6,   -33,   -33,   -33,   -33,
      22
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -1
static const unsigned char yytable[] =
{
      39,    47,    29,    30,    31,    92,    95,    32,    82,    85,
      29,    30,    31,    90,    28,    32,    29,    30,    31,   108,
      97,    32,    29,    30,    31,    69,    70,    32,    29,    30,
      31,    73,    99,    32,    74,   110,    41,    79,    42,    43,
      41,    83,    42,    43,    96,    84,   111,    93,    41,   112,
      42,    43,   113,   109,    91,    29,    30,    31,    98,    33,
      32,    35,    36,    71,    37,    38,    75,    76,    69,    70,
     100,    81,    77,    24,    25,    26,    80,   147,    73,    44,
      89,    74,   101,    46,    27,   105,   106,   114,   102,   103,
     104,   116,   117,   118,   119,   141,   142,    86,    87,   146,
      88,   107,   120,   159,     1,     2,     3,     4,     5,     6,
       7,     8,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    21,   121,   122,   123,     0,    48,
      49,    50,    51,    52,    53,    54,    22,    55,    56,    57,
      58,    59,    60,    61,    62,    63,    64,    65,    66,    67,
     124,   125,   126,   127,   128,   129,   130,   131,   132,   133,
     134,    68,   135,   136,   137,   138,   139,   140,   143,   144,
     145,   148,   149,   150,   151,   152,   153,   154,   155,   156,
     157,   160,   161,   162,   163,   164,   165,   166,   167,   168,
     170,   171,   172
};

static const yysigned_char yycheck[] =
{
       5,     7,     3,     4,     5,     4,     8,     8,    13,    14,
       3,     4,     5,     5,    46,     8,     3,     4,     5,    12,
       8,     8,     3,     4,     5,     8,     9,     8,     3,     4,
       5,     5,     8,     8,     8,    40,     3,    46,     5,     6,
       3,    42,     5,     6,    46,    46,     5,    46,     3,     8,
       5,     6,    11,    46,    46,     3,     4,     5,    46,    46,
       8,    43,    44,    46,    46,    46,    40,    41,     8,     9,
      46,    46,    46,    35,    36,    37,    46,    83,     5,    46,
      16,     8,     0,    46,    46,    46,    46,    46,    24,    25,
      26,    38,    39,    40,    41,    73,    74,    43,    44,    11,
      46,    46,    46,   108,    14,    15,    16,    17,    18,    19,
      20,    21,    22,    23,    24,    25,    26,    27,    28,    29,
      30,    31,    32,    33,    34,    46,    46,    46,    -1,    14,
      15,    16,    17,    18,    19,    20,    46,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      46,    46,    46,    46,    46,    46,    46,    46,    46,    46,
      46,    46,    46,    46,    46,    46,    46,    46,    46,    46,
      46,    46,    46,    46,    46,    46,    46,    46,    46,    46,
       8,    46,    46,     5,     5,    46,    46,    46,    46,     5,
      46,    46,    46
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,    14,    15,    16,    17,    18,    19,    20,    21,    22,
      23,    24,    25,    26,    27,    28,    29,    30,    31,    32,
      33,    34,    46,    48,    35,    36,    37,    46,    46,     3,
       4,     5,     8,    46,    51,    43,    44,    46,    46,    51,
      54,     3,     5,     6,    46,    52,    46,    52,    14,    15,
      16,    17,    18,    19,    20,    22,    23,    24,    25,    26,
      27,    28,    29,    30,    31,    32,    33,    34,    46,     8,
       9,    46,    49,     5,     8,    40,    41,    46,    57,    46,
      46,    46,    51,    42,    46,    51,    43,    44,    46,    49,
       5,    46,     4,    46,    53,     8,    46,     8,    46,     8,
      46,     0,    49,    49,    49,    46,    46,    46,    12,    46,
      51,     5,     8,    11,    46,    56,    38,    39,    40,    41,
      46,    46,    46,    46,    46,    46,    46,    46,    46,    46,
      46,    46,    46,    46,    46,    46,    46,    46,    46,    46,
      46,    57,    57,    46,    46,    46,    11,    52,    46,    46,
      46,    46,    46,    46,    46,    46,    46,     8,    55,    51,
      46,    46,     5,     5,    46,    46,    46,    46,     5,    50,
      46,    46,    46
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)		\
   ((Current).first_line   = (Rhs)[1].first_line,	\
    (Current).first_column = (Rhs)[1].first_column,	\
    (Current).last_line    = (Rhs)[N].last_line,	\
    (Current).last_column  = (Rhs)[N].last_column)
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if defined (YYMAXDEPTH) && YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 132 "gram.y"
    {
		param.number = OPEN; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 3:
#line 136 "gram.y"
    {
		opendso(yyvsp[-3].y_str, yyvsp[-2].y_str, yyvsp[-1].y_num);
		stmt_type = OPEN; YYACCEPT;
	    }
    break;

  case 4:
#line 140 "gram.y"
    {
		openpmda(yyvsp[-1].y_str);
		stmt_type = OPEN; YYACCEPT;
	    }
    break;

  case 5:
#line 144 "gram.y"
    {
		opensocket(yyvsp[0].y_str);
		stmt_type = OPEN; YYACCEPT;
	    }
    break;

  case 6:
#line 148 "gram.y"
    { 
		stmt_type = CLOSE; YYACCEPT; 
	    }
    break;

  case 7:
#line 151 "gram.y"
    {
		param.number = DESC; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 8:
#line 155 "gram.y"
    {
		param.pmid = yyvsp[-1].y_num;
		stmt_type = DESC; YYACCEPT;
	    }
    break;

  case 9:
#line 159 "gram.y"
    {
		param.number = FETCH; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 10:
#line 163 "gram.y"
    { 
		stmt_type = FETCH; YYACCEPT; 
	    }
    break;

  case 11:
#line 166 "gram.y"
    {
		param.number = STORE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 12:
#line 170 "gram.y"
    {
		param.name = yyvsp[-1].y_str;
		param.pmid = (pmID)yyvsp[-2].y_num;
		stmt_type = STORE; YYACCEPT;
	    }
    break;

  case 13:
#line 175 "gram.y"
    {
		param.number = INFO; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 14:
#line 179 "gram.y"
    {
		param.number = PM_TEXT_PMID;
		param.pmid = (pmID)yyvsp[-1].y_num;
		stmt_type = INFO; YYACCEPT;
	    }
    break;

  case 15:
#line 184 "gram.y"
    {
		param.number = PM_TEXT_INDOM;
		param.indom = indom.whole;
		stmt_type = INFO; YYACCEPT;
	    }
    break;

  case 16:
#line 189 "gram.y"
    {
		param.number = INSTANCE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 17:
#line 193 "gram.y"
    {
		param.indom = indom.whole;
		param.number = PM_IN_NULL;
		param.name = NULL;
		stmt_type = INSTANCE; YYACCEPT;
	    }
    break;

  case 18:
#line 199 "gram.y"
    {
		param.indom = indom.whole;
		param.number = yyvsp[-1].y_num;
		param.name = NULL;
		stmt_type = INSTANCE; YYACCEPT;
	    }
    break;

  case 19:
#line 205 "gram.y"
    {
		param.indom = indom.whole;
		param.number = PM_IN_NULL;
		param.name = yyvsp[-1].y_str;
		stmt_type = INSTANCE; YYACCEPT;
	    }
    break;

  case 20:
#line 211 "gram.y"
    {
		param.number = PROFILE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 21:
#line 215 "gram.y"
    {
		sts = pmAddProfile(yyvsp[-2].y_num, 0, NULL);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    }
    break;

  case 22:
#line 225 "gram.y"
    {
		sts = pmDelProfile(yyvsp[-2].y_num, 0, NULL);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    }
    break;

  case 23:
#line 235 "gram.y"
    {
		inst = yyvsp[-1].y_num;
		sts = pmAddProfile(yyvsp[-3].y_num, 1, &inst);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    }
    break;

  case 24:
#line 246 "gram.y"
    {
		inst = yyvsp[-1].y_num;
		sts = pmDelProfile(yyvsp[-3].y_num, 1, &inst);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		profile_changed = 1;
		stmt_type = EOL;
		YYACCEPT;
	    }
    break;

  case 25:
#line 257 "gram.y"
    {
		param.number = WATCH; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 26:
#line 261 "gram.y"
    {
		watch(yyvsp[-1].y_str);
		stmt_type = WATCH; YYACCEPT;
	    }
    break;

  case 27:
#line 265 "gram.y"
    {
		param.number = PMNS_NAME; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 28:
#line 269 "gram.y"
    {
		param.pmid = yyvsp[-1].y_num;
		stmt_type = PMNS_NAME; YYACCEPT;
	    }
    break;

  case 29:
#line 273 "gram.y"
    {
		param.number = PMNS_PMID; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 30:
#line 277 "gram.y"
    {
		param.name = yyvsp[-1].y_str;
		stmt_type = PMNS_PMID; YYACCEPT;
	    }
    break;

  case 31:
#line 281 "gram.y"
    {
		param.number = PMNS_CHILDREN; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 32:
#line 285 "gram.y"
    {
		param.name = yyvsp[-1].y_str;
		stmt_type = PMNS_CHILDREN; YYACCEPT;
	    }
    break;

  case 33:
#line 289 "gram.y"
    {
		param.number = PMNS_TRAVERSE; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 34:
#line 293 "gram.y"
    {
		param.name = yyvsp[-1].y_str;
		stmt_type = PMNS_TRAVERSE; YYACCEPT;
	    }
    break;

  case 35:
#line 297 "gram.y"
    {
		param.name = yyvsp[-1].y_str;
		stmt_type = NAMESPACE; YYACCEPT;
	    }
    break;

  case 36:
#line 302 "gram.y"
    { 
		param.number = -1; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT; 
	    }
    break;

  case 37:
#line 306 "gram.y"
    {
		param.number = CLOSE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 38:
#line 310 "gram.y"
    {
		param.number = DBG; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 39:
#line 314 "gram.y"
    {
		param.number = DESC; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 40:
#line 318 "gram.y"
    {
		param.number = FETCH; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 41:
#line 322 "gram.y"
    {
		param.number = GETDESC; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 42:
#line 326 "gram.y"
    {
		param.number = INFO; param.pmid = HELP_FULL;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 43:
#line 330 "gram.y"
    {
		param.number = INSTANCE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 44:
#line 334 "gram.y"
    {
		param.number = NAMESPACE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 45:
#line 338 "gram.y"
    {
		param.number = OPEN; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 46:
#line 342 "gram.y"
    {
		param.number = PMNS_CHILDREN; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 47:
#line 346 "gram.y"
    {
		param.number = PMNS_NAME; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 48:
#line 350 "gram.y"
    {
		param.number = PMNS_PMID; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 49:
#line 354 "gram.y"
    {
		param.number = PMNS_TRAVERSE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 50:
#line 358 "gram.y"
    {
		param.number = PROFILE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 51:
#line 362 "gram.y"
    {
		param.number = QUIT; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 52:
#line 366 "gram.y"
    {
		param.number = STATUS; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 53:
#line 370 "gram.y"
    {
		param.number = STORE; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 54:
#line 374 "gram.y"
    {
		param.number = TIMER; param.pmid = HELP_FULL;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 55:
#line 378 "gram.y"
    {
		param.number = WAIT; param.pmid = HELP_FULL;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 56:
#line 382 "gram.y"
    {
		param.number = WATCH; param.pmid = HELP_FULL; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 57:
#line 387 "gram.y"
    { stmt_type = QUIT; YYACCEPT; }
    break;

  case 58:
#line 388 "gram.y"
    {
		param.number = DBG; param.pmid = HELP_USAGE; 
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 59:
#line 392 "gram.y"
    {
		param.number = -1;
		stmt_type = DBG; YYACCEPT;
	    }
    break;

  case 60:
#line 396 "gram.y"
    {
		param.number = 0;
		stmt_type = DBG; YYACCEPT;
	    }
    break;

  case 61:
#line 400 "gram.y"
    {
		param.number = yyvsp[-1].y_num;
	        stmt_type = DBG; YYACCEPT;
	    }
    break;

  case 62:
#line 404 "gram.y"
    { 
		stmt_type = STATUS; YYACCEPT; 
	    }
    break;

  case 63:
#line 407 "gram.y"
    {
		param.number = TIMER; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 64:
#line 411 "gram.y"
    { 
		timer = 1; stmt_type = EOL; YYACCEPT; 
	    }
    break;

  case 65:
#line 414 "gram.y"
    { 
		timer = 0; stmt_type = EOL; YYACCEPT; 
	    }
    break;

  case 66:
#line 417 "gram.y"
    {
		param.number = GETDESC; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 67:
#line 421 "gram.y"
    { 
		get_desc = 1; stmt_type = EOL; YYACCEPT; 
	    }
    break;

  case 68:
#line 424 "gram.y"
    { 
		get_desc = 0; stmt_type = EOL; YYACCEPT; 
	    }
    break;

  case 69:
#line 427 "gram.y"
    {
		param.number = WAIT; param.pmid = HELP_USAGE;
		stmt_type = HELP; YYACCEPT;
	    }
    break;

  case 70:
#line 431 "gram.y"
    { 
		stmt_type = EOL; sleep(yyvsp[-1].y_num); YYACCEPT;
	    }
    break;

  case 71:
#line 434 "gram.y"
    { stmt_type = EOL; YYACCEPT; }
    break;

  case 72:
#line 435 "gram.y"
    {
		if (yywrap())
		    YYACCEPT;
		else {
		    yyerror("Unrecognized command");
		    YYERROR;
		}
	    }
    break;

  case 73:
#line 445 "gram.y"
    { yyval.y_str = strcons("./", yyvsp[0].y_str); }
    break;

  case 74:
#line 446 "gram.y"
    { yyval.y_str = yyvsp[0].y_str; }
    break;

  case 75:
#line 449 "gram.y"
    { yyval.y_num = yyvsp[0].y_num; }
    break;

  case 76:
#line 450 "gram.y"
    { yyval.y_num = 0; }
    break;

  case 77:
#line 453 "gram.y"
    { 
		pmid.whole = yyvsp[0].y_num;
		sts = pmNameID(pmid.whole, &str);
		if (sts < 0) {
		    sprintf(warnStr, "PMID (%s) is not defined in the PMNS",
			    pmIDStr(pmid.whole));
		    yywarn(warnStr);
		}
		else
		    free(str);
		yyval.y_num = (int)pmid.whole; 
	    }
    break;

  case 78:
#line 465 "gram.y"
    {
		pmid.whole = 0;
		pmid.part.cluster = yyvsp[0].y_2num.num1;
		pmid.part.item = yyvsp[0].y_2num.num2;
		sts = pmNameID(pmid.whole, &str);
		if (sts < 0) {
		    sprintf(warnStr, "PMID (%s) is not defined in the PMNS",
			    pmIDStr(pmid.whole));
		    yywarn(warnStr);
		}
		else
		    free(str);
		yyval.y_num = (int)pmid.whole;
	    }
    break;

  case 79:
#line 479 "gram.y"
    {
		pmid.whole = 0;
		pmid.part.domain = yyvsp[0].y_3num.num1;
		pmid.part.cluster = yyvsp[0].y_3num.num2;
		pmid.part.item = yyvsp[0].y_3num.num3;
		sts = pmNameID(pmid.whole, &str);
		if (sts < 0) {
		    sprintf(warnStr, "PMID (%s) is not defined in the PMNS",
			    pmIDStr(pmid.whole));
		    yywarn(warnStr);
		}
		else
		    free(str);
		yyval.y_num = (int)pmid.whole;
	    }
    break;

  case 80:
#line 494 "gram.y"
    {
		sts = pmLookupName(1, &yyvsp[0].y_str, &pmid.whole);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		sts = fix_dynamic_pmid(yyvsp[0].y_str, &pmid.whole);
		if (sts < 0) {
		    yyerror(pmErrStr(sts));
		    YYERROR;
		}
		yyval.y_num = (int)pmid.whole;
	    }
    break;

  case 81:
#line 509 "gram.y"
    { 
		indom.whole = yyvsp[0].y_num;
	        yyval.y_num = (int)indom.whole;
	    }
    break;

  case 82:
#line 513 "gram.y"
    { 
		indom.whole = yyvsp[0].y_num;
		yyval.y_num = (int)indom.whole;
	    }
    break;

  case 83:
#line 517 "gram.y"
    {
		indom.whole = 0;
		indom.part.domain = yyvsp[0].y_2num.num1;
		indom.part.serial = yyvsp[0].y_2num.num2;
		yyval.y_num = (int)indom.whole;
	    }
    break;

  case 84:
#line 525 "gram.y"
    {
		pmid.whole = 0;
		pmid.part.domain = yyvsp[0].y_3num.num1;
		pmid.part.cluster = yyvsp[0].y_3num.num2;
		pmid.part.item = yyvsp[0].y_3num.num3;
		yyval.y_num = (int)pmid.whole;
	    }
    break;

  case 85:
#line 534 "gram.y"
    { addmetriclist((pmID)yyvsp[0].y_num); }
    break;

  case 86:
#line 535 "gram.y"
    { addmetriclist((pmID)yyvsp[0].y_num); }
    break;

  case 87:
#line 536 "gram.y"
    { addmetriclist((pmID)yyvsp[0].y_num); }
    break;

  case 88:
#line 540 "gram.y"
    { doargs(); }
    break;

  case 89:
#line 543 "gram.y"
    { yyval.y_str = yyvsp[0].y_str; }
    break;

  case 90:
#line 544 "gram.y"
    { yyval.y_str = yyvsp[0].y_str; }
    break;

  case 91:
#line 547 "gram.y"
    { yyval.y_num = yyvsp[0].y_num; }
    break;

  case 92:
#line 548 "gram.y"
    {
			sts = __pmParseDebug(yyvsp[0].y_str);
			if (sts < 0) {
			    sprintf(warnStr, "Bad debug flag (%s)", yyvsp[0].y_str);
			    yywarn(warnStr);
			    YYERROR;
			}
			yyval.y_num = sts;
		    }
    break;

  case 93:
#line 557 "gram.y"
    { yyval.y_num = yyvsp[-1].y_num | yyvsp[0].y_num; }
    break;

  case 94:
#line 558 "gram.y"
    {
			sts = __pmParseDebug(yyvsp[-1].y_str);
			if (sts < 0) {
			    sprintf(warnStr, "Bad debug flag (%s)", yyvsp[-1].y_str);
			    yywarn(warnStr);
			    YYERROR;
			}
			yyval.y_num = sts | yyvsp[0].y_num;
		    }
    break;


    }

/* Line 1000 of yacc.c.  */
#line 2083 "gram.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  const char* yyprefix;
	  char *yymsg;
	  int yyx;

	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  int yyxbegin = yyn < 0 ? -yyn : 0;

	  /* Stay within bounds of both yycheck and yytname.  */
	  int yychecklim = YYLAST - yyn;
	  int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
	  int yycount = 0;

	  yyprefix = ", expecting ";
	  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      {
		yysize += yystrlen (yyprefix) + yystrlen (yytname [yyx]);
		yycount += 1;
		if (yycount == 5)
		  {
		    yysize = 0;
		    break;
		  }
	      }
	  yysize += (sizeof ("syntax error, unexpected ")
		     + yystrlen (yytname[yytype]));
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yyprefix = ", expecting ";
		  for (yyx = yyxbegin; yyx < yyxend; ++yyx)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			yyp = yystpcpy (yyp, yyprefix);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yyprefix = " or ";
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* If at end of input, pop the error token,
	     then the rest of the stack, then return failure.  */
	  if (yychar == YYEOF)
	     for (;;)
	       {
		 YYPOPSTACK;
		 if (yyssp == yyss)
		   YYABORT;
		 YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
		 yydestruct (yystos[*yyssp], yyvsp);
	       }
        }
      else
	{
	  YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
	  yydestruct (yytoken, &yylval);
	  yychar = YYEMPTY;

	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

#ifdef __GNUC__
  /* Pacify GCC when the user code never invokes YYERROR and the label
     yyerrorlab therefore never appears in user code.  */
  if (0)
     goto yyerrorlab;
#endif

  yyvsp -= yylen;
  yyssp -= yylen;
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      YYPOPSTACK;
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 569 "gram.y"


